#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n;

struct node {
    int mx, mn;
    int add;
};

vector<ll> h;
vector<node> t;

void build(int v = 0, int tl = 0, int tr = n) {
    if (tr == tl + 1) {
        t[v] = {tl, tl, 0};
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm);
    build(2 * v + 2, tm, tr);
    t[v].mx = max(t[2 * v + 1].mx, t[2 * v + 2].mx);
    t[v].mn = min(t[2 * v + 1].mn, t[2 * v + 2].mn);
}

void push(int v) {
    t[v].mx += t[v].add;
    t[v].mn += t[v].add;
    t[2 * v + 1].add += t[v].add;
    t[2 * v + 2].add += t[v].add;
    t[v].add = 0;
}

void add(int l, int r, int val, int v = 0, int tl = 0, int tr = n) {
    if (r <= tl || tr <= l) return;
    if (l <= tl && tr <= r) {
        t[v].add += val;
        t[v].mx += val;
        t[v].mn += val;
        return;
    }
    int tm = (tl + tr) / 2;
    push(v);
    add(l, r, val, 2 * v + 1, tl, tm);
    add(l, r, val, 2 * v + 2, tm, tr);
    t[v].mx = max(t[2 * v + 1].mx, t[2 * v + 2].mx);
    t[v].mn = min(t[2 * v + 1].mn, t[2 * v + 2].mn);
}

int sl(int val, int v = 0, int tl = 0, int tr = n) {
    if (tr == tl + 1) return tl;
    int tm = (tl + tr) / 2;
    if (t[2 * v + 1].mx < val) {
        return sl(val, 2 * v + 2, tm, tr);
    }
    return sl(val, 2 * v + 1, tl, tm);
}

int sr(int val, int v = 0, int tl = 0, int tr = n) {
    if (tr == tl + 1) return tl;
    int tm = (tl + tr) / 2;
    if (t[2 * v + 2].mn > val) {
        return sr(val, 2 * v + 1, tl, tm);
    }
    return sr(val, 2 * v + 2, tm, tr);
}

int mx(int l, int r, int v = 0, int tl = 0, int tr = n) {
    if (l <= tl && tr <= r) return t[v].mx;
    if (r <= tl || tr <= l) return -1;
    int tm = (tl + tr) / 2;
    return max(mx(l, r, 2 * v + 1, tl, tm), mx(l, r, 2 * v + 2, tm, tr));
}

int main() {
    cin >> n;
    h.resize(n);
    t.resize(n * 4);
    build();
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
    }
    int l = 0, r = 0;
    for (int i = 1; i < n; ++i) {
        if (h[i] <= h[i - 1]) r = i;
    }
    for (int i = r; i >= 0; --i) {
        if (h[r] == h[i]) l = i;
    }
    for (int i = 0; i < n - 1; ++i) {
        int k;
        cin >> k;
        --k;
        int l1 = sl(k), r1 = sr(k), l2 = r1 + 1, r2 = sr(k + 1);
        if (l1 <= l && r <= r2) {
            if (h[l1] == h[r2]) {
                cout << h[l1] * (r2 - l1 + 1) - (pref[r2 + 1] - pref[l]) << "\n";
            } else if (h[l1] < h[r2]) {
                int ll = r, rr = r2 + 1;
                while (rr > ll + 1) {
                    int mm = (ll + rr) / 2;
                    if (h[mm] > h[l1]) {
                        rr = mm;
                    } else {
                        ll = mm;
                    }
                }
                if (h[ll] < h[l1]) ++ll;
                cout << h[l1] * (ll - l1 + 1) - (pref[ll + 1] - pref[l]) << "\n";
            } else {
                int ll = l1, rr = l + 1;
                while (rr > ll + 1) {
                    int mm = (ll + rr) / 2;
                    if (h[mm] > h[l2]) {
                        rr = mm;
                    } else {
                        ll = mm;
                    }
                }
                if (h[ll] < h[l2]) ++ll;
                cout << h[r2] * (r2 - ll + 1) - (pref[r2 + 1] - pref[ll]) << "\n";
            }
        } else {
            cout << "0\n";
        }
        add(l2, n, -1);
    }
}