#include <bits/stdc++.h>

using namespace std;
using ll = long long;

unordered_map<ll, ll> mp;

void factor(ll d) {
    ll p = 2;
    while (d > 1 && p * p <= d) {
        while (d % p == 0) {
            mp[p]++;
            d /= p;
        }
        ++p;
    }
    if (d > 1) {
        mp[d]++;
    }
}

ll ans = 0;
ll d, l, r;

void rec(ll cur) {
    ll x2 = d / cur + cur;
    ll y2 = d / cur - cur;
    if (x2 % 2 == 0 && y2 % 2 == 0 && y2 > 0) {
        ll x = x2 * x2 / 4;
        ll y = y2 * y2 / 4;
        if (x <= r && y >= l) {
            ++ans;
        }
    }
    for (auto& it : mp) {
        if (it.second > 0) {
            --it.second;
            rec(cur * it.first);
            ++it.second;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin >> d >> l >> r;
    factor(d);
    rec(1);
    cout << ans << endl;
}