#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<ll> t;

void build(int v, int tl, int tr, vector<ll>& ar) {
    if (tr == tl + 1) {
        t[v] = ar[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm, ar);
    build(2 * v + 2, tm, tr, ar);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

int get(int l, int r, int v, int tl, int tr) {
    if (l <= tl && tr <= r) return t[v];
    if (r <= tl || tr <= l) return 1e9 + 7;
    int tm = (tl + tr) / 2;
    return min(get(l, r, 2 * v + 1, tl, tm), get(l, r, 2 * v + 2, tm, tr));
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, k;
    cin >> n >> k;
    vector<ll> ar(n), pref(n + 1);
    t.resize(4 * n, 1e9 + 7);
    for (int i = 0; i < n; i++) {
        cin >> ar[i];
        pref[i + 1] = pref[i] + ar[i];
    }
    build(0, 0, n, ar);
    if (k == 2) {
        ll ans = -1;
        for (int i = 0; i < n - 1; ++i) {
            ll sm1 = pref[i + 1], sm2 = pref[n] - pref[i + 1];
            ans = max(ans, abs(sm1 - sm2));
        }
        cout << ans << endl;
        return 0;
    }
    if (k == n) {
        ll mx = ar[0], mn = ar[0];
        for (int i = 1; i < n; ++i) {
            mx = max(mx, ar[i]);
            mn = min(mn, ar[i]);
        }
        cout << mx - mn << endl;
        return 0;
    }
    ll ans = -1;
    for (int i = 0; i < k; ++i) {
        ll sm = pref[i + n - k + 1] - pref[i];
        ll mn = min(get(0, i, 0, 0, n), get(i + n - k + 1, n, 0, 0, n));
        ans = max(ans, sm - mn);
    }
    for (int i = 0; i < n - k; ++i) {
        ll sm = pref[i + 1];
        ll mn = get(i + 1, n, 0, 0, n);
        ans = max(ans, sm - mn);
    }
    for (int i = k; i < n; ++i) {
        ll sm = pref[n] - pref[i];
        ll mn = get(0, i, 0, 0, n);
        ans = max(ans, sm - mn);
    }
    cout << ans << endl;
}